///
/// @file
/// @brief cmeta::Element
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "Element.hpp"

namespace cmeta {

//
// RXgN^
//
Element::Element(const std::string& iName):mName(iName)
{
	// do nothing.
}

//
// Rs[ RXgN^
//
Element::Element(const Element& iSource):mName(iSource.mName)
{
	// do nothing.
}

//
// fXgN^
//
Element::~Element()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void Element::swap(Element& ioSource)	// nothrow
{
	std::swap(mName, ioSource.mName);
}

};
