///
/// @file
/// @brief cmeta::Function
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_FUNCTION_HPP_INCLUDED
#define CTOXMI_CMETA_FUNCTION_HPP_INCLUDED

#include "PrimitiveFunction.hpp"
#include "IFunction.hpp"
#include "Element.hpp"

namespace cmeta {

///
/// ֐vfNX
///
class Function:
	public Element,
	public IFunction {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iName Ow肷B
	/// @param[in] iType ߂ľ^w肷B
	///
	explicit Function(const std::string& iName, const Type* iType);
	
	///
	/// Rs[ RXgN^
	///
	Function(const Function& iSource);
	
	///
	/// fXgN^
	///
	virtual ~Function();	// nothrow
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(Function& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	Function& operator=(const Function& iSource);
	
protected:
	///
	/// ߂ľ^擾B
	///
	/// @return ߂ľ^ԂB
	///
	virtual const Type& getTypeImpl() const;
	
	///
	/// Xg̐擪擾B
	///
	/// @return Xg̐擪ԂB
	///
	virtual IFunction::const_iterator beginImpl() const;
	
	///
	/// Xg̖擾B
	///
	/// @return Xg̖ԂB
	///
	virtual IFunction::const_iterator endImpl() const;
	
private:
	PrimitiveFunction mImpl;
};

};

#endif
