///
/// @file
/// @brief cmeta::IFunction
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_IFUNCTIONT_HPP_INCLUDED
#define CTOXMI_CMETA_IFUNCTIONT_HPP_INCLUDED

#include "Variable.hpp"
#include "Type.hpp"
#include <vector>

namespace cmeta {

///
/// ֐C^tF[X
///
class IFunction {
	
protected:
	///
	/// ftHg RXgN^
	///
	IFunction()
	{
		// do nothing.
	}
	
	///
	/// Rs[ RXgN^
	///
	IFunction(const IFunction& iSource)
	{
		// do nothing.
	}
	
public:
	///
	/// fXgN^
	///
	virtual ~IFunction()	// nothrow
	{
		// do nothing.
	}
	
	///
	/// ߂ľ^擾B
	///
	/// @return ߂ľ^ԂB
	///
	const Type& getType() const
	{
		return getTypeImpl();
	}
	
	///
	/// Xg̃Ce[^
	///
	typedef std::vector<Variable>::const_iterator const_iterator;
	
	///
	/// Xg̐擪擾B
	///
	/// @return Xg̐擪ԂB
	///
	const_iterator begin() const
	{
		return beginImpl();
	}
	
	///
	/// Xg̖擾B
	///
	/// @return Xg̖ԂB
	///
	const_iterator end() const
	{
		return endImpl();
	}
	
protected:
	///
	/// ߂ľ^擾B
	///
	/// @return ߂ľ^ԂB
	///
	virtual const Type& getTypeImpl() const = 0;
	
	///
	/// Xg̐擪擾B
	///
	/// @return Xg̐擪ԂB
	///
	virtual const_iterator beginImpl() const = 0;
	
	///
	/// Xg̖擾B
	///
	/// @return Xg̖ԂB
	///
	virtual const_iterator endImpl() const = 0;
};

};

#endif
