///
/// @file
/// @brief cmeta::Location
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "Location.hpp"

namespace cmeta {

//
// RXgN^
//
Location::Location(const std::string& iPath):mPath(iPath)
{
	// do nothing.
}

//
// Rs[ RXgN^
//
Location::Location(const Location& iSource):mPath(iSource.mPath)
{
	// do nothing.
}

///
/// fXgN^
///
Location::~Location()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void Location::swap(Location& ioSource)	// nothrow
{
	std::swap(mPath, ioSource.mPath);
}

//
// Rs[Zq
//
Location& Location::operator=(const Location& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
