///
/// @file
/// @brief cmeta::Macro
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_MACRO_HPP_INCLUDED
#define CTOXMI_CMETA_MACRO_HPP_INCLUDED

#include "Element.hpp"

namespace cmeta {

///
/// }NvfNX
///
class Macro:
	public Element {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iName Ow肷B
	///
	explicit Macro(const std::string& iName);
	
	///
	/// Rs[ RXgN^
	///
	/// @param[in] iSource Rs[w肷B
	///
	Macro(const Macro& iSource);
	
	///
	/// fXgN^
	///
	virtual ~Macro();	// nothrow
	
	///
	/// }N`̒u敶 1 sǉB
	///
	/// @param[in] iLine 1 s̕w肷B
	///
	void addBody(const std::string& iLine);
	
	///
	/// }N`̒u敶擾B
	///
	/// @return }N`̒u敶ԂB
	///
	const std::string& getBody() const
	{
		return mBody;
	}
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(Macro& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	Macro& operator=(const Macro& iSource);
	
private:
	std::string mBody;
};

};

#endif
