///
/// @file
/// @brief cmeta::Structure
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_STRUCTURE_HPP_INCLUDED
#define CTOXMI_CMETA_STRUCTURE_HPP_INCLUDED

#include "Variable.hpp"
#include "Type.hpp"
#include <vector>

namespace cmeta {

///
/// \̗vfNX
///
class Structure:
	public Type {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iName Ow肷B
	///
	explicit Structure(const std::string& iName);
	
	///
	/// Rs[ RXgN^
	///
	/// @param[in] iSource Rs[w肷B
	///
	Structure(const Structure& iSource);
	
	///
	/// fXgN^
	///
	virtual ~Structure();	// nothrow
	
	///
	/// oϐǉB
	///
	/// @param[in] iMember oϐw肷B
	///
	void add(const Variable& iMember);
	
	///
	/// oϐXg̃Ce[^
	///
	typedef std::vector<Variable>::const_iterator const_iterator;
	
	///
	/// oϐXg̐擪擾B
	///
	/// @return 񋓒lXg̐擪ԂB
	///
	const_iterator begin() const
	{
		return mMembers.begin();
	}
	
	///
	/// oϐXg̖擾B
	///
	/// @return 񋓒lXg̖ԂB
	///
	const_iterator end() const
	{
		return mMembers.end();
	}
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(Structure& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	Structure& operator=(const Structure& iSource);
	
private:
	std::vector<Variable> mMembers;
};

};

#endif
