///
/// @file
/// @brief cmeta::Synonym
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_SYNONYM_HPP_INCLUDED
#define CTOXMI_CMETA_SYNONYM_HPP_INCLUDED

#include "Type.hpp"

namespace cmeta {

///
/// VmjvfNX
///
class Synonym:
	public Type {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iName Ow肷B
	/// @param[in] iType ^w肷B
	///
	explicit Synonym(const std::string& iName, const Type* iType);
	
	///
	/// Rs[ RXgN^
	///
	/// @param[in] iSource Rs[w肷B
	///
	Synonym(const Synonym& iSource);
	
	///
	/// fXgN^
	///
	virtual ~Synonym();	// nothrow
	
	///
	/// ^擾B
	///
	/// @return ^ԂB
	///
	const Type& getType() const
	{
		return *mType;
	}
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(Synonym& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	Synonym& operator=(const Synonym& iSource);
	
private:
	const Type* mType;
};

};

#endif
