///
/// @file
/// @brief cmeta::Variable
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_VARIABLE_HPP_INCLUDED
#define CTOXMI_CMETA_VARIABLE_HPP_INCLUDED

#include "Type.hpp"
#include "Element.hpp"

namespace cmeta {

///
/// ϐvfNX
///
class Variable:
	public Element {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iName Ow肷B
	/// @param[in] iType ^w肷B
	///
	explicit Variable(const std::string& iName, const Type* iType);
	
	///
	/// Rs[ RXgN^
	///
	/// @param[in] iSource Rs[w肷B
	///
	Variable(const Variable& iSource);
	
	///
	/// fXgN^
	///
	virtual ~Variable();	// nothrow
	
	///
	/// ^擾B
	///
	/// @return ^ԂB
	///
	const Type& getType() const
	{
		return *mType;
	}
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(Variable& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	Variable& operator=(const Variable& iSource);
	
private:
	const Type* mType;
};

};

#endif
