///
/// @file
/// @brief cparser::LexerItem
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CPARSER_LEXERITEM_HPP_INCLUDED
#define CTOXMI_CPARSER_LEXERITEM_HPP_INCLUDED

#include "LexerItemType.hpp"
#include <cstdint>

namespace cparser {

///
/// LT[͍̉
///
struct LexerItem {
	
	///
	/// 
	///
	LexerItemType type;
	
	///
	/// p̕
	///
	char* pattern;
	
	///
	/// o̒ʒmR[h
	///
	std::uint32_t code;
	
	///
	/// XLbv
	///
	static const std::uint32_t codeSkip = 0xFFFFFFFF;
	
};

};

#endif
