///
/// @file
/// @brief cmeta::BuiltIn
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "BuiltIn.hpp"

namespace cmeta {

//
// RXgN^
//
BuiltIn::BuiltIn(const std::string& iName):Type(iName)
{
	// do nothing.
}

//
// Rs[ RXgN^
//
BuiltIn::BuiltIn(const BuiltIn& iSource):Type(iSource)
{
	// do nothing.
}

//
// fXgN^
//
BuiltIn::~BuiltIn()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void BuiltIn::swap(BuiltIn& ioSource)	// nothrow
{
	Type::swap(ioSource);
}

//
// Rs[Zq
//
BuiltIn& BuiltIn::operator=(const BuiltIn& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
