///
/// @file
/// @brief cmeta::ElementCollection
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_ELEMENTCOLLECTION_HPP_INCLUDED
#define CTOXMI_CMETA_ELEMENTCOLLECTION_HPP_INCLUDED

#include "ElementItem.hpp"
#include "Element.hpp"
#include <vector>
#include <memory>

namespace cmeta {

///
/// C ͗vf̃RNV NX
///
class ElementCollection {
	
public:
	///
	/// ftHg RXgN^
	///
	ElementCollection();
	
	///
	/// fXgN^
	///
	~ElementCollection();	// nothrow
	
	///
	/// vfǉB
	///
	/// @param[in] iElement vfw肷B
	/// @param[in] iScope XR[vw肷B
	/// @param[in] iLocation ꏊw肷B
	///
	void add(Element* iElement, const Scope iScope, const Location& iLocation);
	
	///
	/// vfXg̃Ce[^
	///
	typedef std::vector<ElementItem>::const_iterator const_iterator;
	
	///
	/// vfXg̐擪擾B
	///
	/// @return 񋓒lXg̐擪ԂB
	///
	const_iterator begin() const
	{
		return mElements.begin();
	}
	
	///
	/// vfXg̖擾B
	///
	/// @return 񋓒lXg̖ԂB
	///
	const_iterator end() const
	{
		return mElements.end();
	}
	
private:
	// Rs[֎~
	ElementCollection(const ElementCollection& iSource);
	ElementCollection& operator=(const ElementCollection& iSource);
	
private:
	std::vector<ElementItem> mElements;
	std::vector<std::shared_ptr<Location> > mLocations;
};

};

#endif
