///
/// @file
/// @brief cmeta::Emumeration
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_ENUMERATION_HPP_INCLUDED
#define CTOXMI_CMETA_ENUMERATION_HPP_INCLUDED

#include "EnumerationConstant.hpp"
#include "Type.hpp"
#include <vector>

namespace cmeta {

///
/// 񋓌^vfNX
///
class Emumeration:
	public Type {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iName Ow肷B
	///
	explicit Emumeration(const std::string& iName);
	
	///
	/// Rs[ RXgN^
	///
	/// @param[in] iSource Rs[w肷B
	///
	Emumeration(const Emumeration& iSource);
	
	///
	/// fXgN^
	///
	virtual ~Emumeration();	// nothrow
	
	///
	/// 񋓒lǉB
	///
	/// @param[in] iConstant 񋓒lw肷B
	///
	void add(const EnumerationConstant& iConstant);
	
	///
	/// 񋓒lXg̃Ce[^
	///
	typedef std::vector<EnumerationConstant>::const_iterator const_iterator;
	
	///
	/// 񋓒lXg̐擪擾B
	///
	/// @return 񋓒lXg̐擪ԂB
	///
	const_iterator begin() const
	{
		return mConstants.begin();
	}
	
	///
	/// 񋓒lXg̖擾B
	///
	/// @return 񋓒lXg̖ԂB
	///
	const_iterator end() const
	{
		return mConstants.end();
	}
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(Emumeration& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	Emumeration& operator=(const Emumeration& iSource);
	
private:
	std::vector<EnumerationConstant> mConstants;
};

};

#endif
