///
/// @file
/// @brief cmeta::EnumerationConstant
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_ENUMERATIONCONSTANT_HPP_INCLUDED
#define CTOXMI_CMETA_ENUMERATIONCONSTANT_HPP_INCLUDED

#include "Element.hpp"

namespace cmeta {

///
/// 񋓒lvfNX
///
class EnumerationConstant:
	public Element {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iName Ow肷B
	/// @param[in] iValue lw肷B
	///
	explicit EnumerationConstant(const std::string& iName, const std::string& iValue);
	
	///
	/// Rs[ RXgN^
	///
	/// @param[in] iSource Rs[w肷B
	///
	EnumerationConstant(const EnumerationConstant& iSource);
	
	///
	/// fXgN^
	///
	virtual ~EnumerationConstant();	// nothrow
	
	///
	/// 񋓒l擾B
	///
	/// @return 񋓒lԂB
	///
	const std::string& getValue() const
	{
		return mValue;
	}
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(EnumerationConstant& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	EnumerationConstant& operator=(const EnumerationConstant& iSource);
	
private:
	std::string mValue;
};

};

#endif
