///
/// @file
/// @brief cmeta::Location
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_LOCATION_HPP_INCLUDED
#define CTOXMI_CMETA_LOCATION_HPP_INCLUDED

#include <string>

namespace cmeta {

///
/// C ͗vf̔zuR[h NX
///
class Location {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iPath pXw肷B
	///
	explicit Location(const std::string& iPath);
	
	///
	/// Rs[ RXgN^
	///
	/// @param[in] iSource Rs[w肷B
	///
	Location(const Location& iSource);
	
	///
	/// fXgN^
	///
	~Location();	// nothrow
	
	///
	/// pX擾B
	///
	/// @return pXԂB
	///
	const std::string& getPath() const
	{
		return mPath;
	}
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(Location& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	Location& operator=(const Location& iSource);
	
private:
	std::string mPath;
};

};

#endif
