///
/// @file
/// @brief cmeta::MacroFunction
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_MACROFUNCTION_HPP_INCLUDED
#define CTOXMI_CMETA_MACROFUNCTION_HPP_INCLUDED

#include "Macro.hpp"
#include <vector>

namespace cmeta {

///
/// t}NvfNX
///
class MacroFunction:
	public Macro {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iName Ow肷B
	///
	explicit MacroFunction(const std::string& iName);
	
	///
	/// Rs[ RXgN^
	///
	/// @param[in] iSource Rs[w肷B
	///
	MacroFunction(const MacroFunction& iSource);
	
	///
	/// fXgN^
	///
	virtual ~MacroFunction();	// nothrow
	
	///
	/// }N`̉ǉB
	///
	/// @param[in] iArgument w肷B
	///
	void addArgument(const std::string& iArgument);
	
	///
	/// Xg̃Ce[^
	///
	typedef std::vector<std::string>::const_iterator const_iterator;
	
	///
	/// Xg̐擪擾B
	///
	/// @return Xg̐擪ԂB
	///
	const_iterator begin() const
	{
		return mArguments.begin();
	}
	
	///
	/// Xg̖擾B
	///
	/// @return Xg̖ԂB
	///
	const_iterator end() const
	{
		return mArguments.end();
	}
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(MacroFunction& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	MacroFunction& operator=(const MacroFunction& iSource);
	
private:
	std::vector<std::string> mArguments;
};

};

#endif
