///
/// @file
/// @brief cmeta::PrimitiveFunction
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CMETA_PRIMITIVEFUNCTION_HPP_INCLUDED
#define CTOXMI_CMETA_PRIMITIVEFUNCTION_HPP_INCLUDED

#include "IFunction.hpp"
#include <vector>

namespace cmeta {

///
/// {IȊ֐NX
///
class PrimitiveFunction:
	public IFunction {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iType ߂ľ^w肷B
	///
	explicit PrimitiveFunction(const Type* iType);
	
	///
	/// Rs[ RXgN^
	///
	PrimitiveFunction(const PrimitiveFunction& iSource);
	
	///
	/// fXgN^
	///
	virtual ~PrimitiveFunction();	// nothrow
	
	///
	/// oϐB
	///
	/// @param[in,out] ioSource Ώۂw肷B
	///
	void swap(PrimitiveFunction& ioSource);	// nothrow
	
	///
	/// Rs[Zq
	///
	/// @param[in] iSource Rs[w肷B
	///
	/// @return Rs[̃IuWFNgւ̎QƂԂB
	///
	PrimitiveFunction& operator=(const PrimitiveFunction& iSource);
	
protected:
	///
	/// ߂ľ^擾B
	///
	/// @return ߂ľ^ԂB
	///
	virtual const Type& getTypeImpl() const;
	
	///
	/// Xg̐擪擾B
	///
	/// @return Xg̐擪ԂB
	///
	virtual IFunction::const_iterator beginImpl() const;
	
	///
	/// Xg̖擾B
	///
	/// @return Xg̖ԂB
	///
	virtual IFunction::const_iterator endImpl() const;
	
private:
	const Type* mType;
	std::vector<Variable> mArguments;
};

};

#endif
